'****************************************************************
'*  Name    : UNTITLED.BAS                                      *
'*  Author  : [select VIEW...EDITOR OPTIONS]                    *
'*  Notice  : Copyright (CC) 2011 [select VIEW...EDITOR OPTIONS] *
'*          : All Rights Reserved                               *
'*  Date    : 1/20/2011                                         *
'*  Version : 1.0                                               *
'*  Notes   :                                                   *
'*          :                                                   *
'****************************************************************
Device 18F452
Xtal 20
;
Declare Optimiser_Level = 2
Declare Dead_Code_Remove = On
Declare Float_Display_Type fast
;
Dim pA_LAT As Float
Dim pB_LAT As Float
Dim pA_LON As Float
Dim pB_LON As Float
;
Dim RESULT As Float 
Dim atanResult As Float
;
Dim AA As Float
Dim aaa As Float
Dim CC As Float
Dim DISTANCE As Float
Dim A1 As Float
Dim A2 As Float
Dim A3 As Float
Dim A4 As Float
Dim dLAT As Float
Dim dLON As Float  

; USER INPUT  GPS VARS HERE
pA_LAT  =  45.0023  
pA_LON  =  27.0223 
pB_LAT  =  45.0023  
pB_LON  =  27.0224
;
$define DEG_PER_RAD    57.295779  ; 57.2957 from radians to degrees
$define EARTH_RADIUS   6371       ; earth radius in km
;
Dim COS_pA_LAT As Float
Dim COS_pB_LAT As Float




;===============================================================================
; uses Les atan2 code as seen here:
;      http://www.protonbasic.co.uk/showthread.php/62055-Trigonometery-problem?p=456258&viewfull=1#post456258
;===============================================================================

    GoTo CALCULATION           ' Jump over the subroutine
'-------------------------------------------------------------------------------------------------------------------------------------  
' Name      : Atan2                                                          
' Purpose   : Computes the principal value of arc tangent of Y/X, using the
'           : signs of both the arguments to determine the quadrant of the return value 
' Input     : PP_AARG holds the Y input
'           : PP_BARG holds the X input
' Output    : PP_AARG holds the arc tangent of Y/X.            
' Notes     : All values are in Radians
'  
'    
' Bring two of the compiler's floating point system variables into the program for the Atan2 macro
'   
    Dim PP_AARG As Float System
    Dim PP_BARG As Float System
  
$define Atan2(pYin, pXin, pResult) '
    PP_AARG = pYin '
    PP_BARG = pXin '
    _Atan2         '
    pResult = PP_AARG
 
_Atan2 Macro-
    GoSub __Atan2
Endm 
 
#ifMacro- _Atan2    
__Atan2:            
    Dim fYin As PP_AARG
    Dim fXin As PP_BARG
    Dim bQuadrant As Byte System
    Dim tSign As bQuadrant.7

    tSign = 0
    bQuadrant = 0

    If fYin <= 0.0 Then 
        If fXin <= 0.0 Then 
            bQuadrant = 3 
        Else 
            bQuadrant = 4 
        EndIf   
    ElseIf fXin < 0.0 Then
        bQuadrant = 2
    Else
        bQuadrant = 1
    EndIf   

    If fYin < 0.0 Then
        tSign = 1
        fYin = Abs fYin
    EndIf
      
    fXin = Abs fXin
    
    If fXin = 0.0 Then
        PP_AARG = 1.570796325
        If tSign = 1 Then
            PP_AARG = -PP_AARG
        EndIf
    Else
        PP_AARG = fYin / fXin
        PP_AARG = ATan(PP_AARG)
        bQuadrant = bQuadrant & %01111111   ' Mask out the Sign bit
        Select bQuadrant
            Case 2
                PP_BARG = PP_AARG
                PP_AARG = 3.14159265 - PP_BARG
            Case 3
                PP_AARG = PP_AARG - 3.14159265
            Case 4
                PP_AARG = -PP_AARG
        EndSelect
    EndIf
    Return
#endIfMacro-

;===============================================================================
; All calculations based on 
; http://www.movable-type.co.uk/scripts/latlong.html
;
;===============================================================================  
CALCULATION:
    ;
    If  pA_LAT = pB_LAT And  pA_LON = pB_LON Then  
        RESULT = 0
        GoTo EXIT_CALC
    EndIf
    ;
    dLAT =  (pB_LAT - pA_LAT) / DEG_PER_RAD       
    dLON =  (pB_LON - pA_LON) / DEG_PER_RAD      
    A2 = Sin(dLON/2)
    A2 = A2 * A2
    A1 = Sin(dLAT/2)  *  Sin (dLAT/2)
    A3 = pA_LAT / DEG_PER_RAD
    COS_pA_LAT = Cos A3
    A3 = pB_LAT / DEG_PER_RAD
    COS_pB_LAT = Cos A3
    AA = COS_pA_LAT *  COS_pB_LAT 
    AA = AA * A2   
    AA = AA + A1    
    A3 = Sqr AA    
    A4 = Sqr 1-AA    
    atan2(A3, A4, aaa)                  
    CC = 2 * aaa   
    DISTANCE = 6371 * CC        ; distance in km    
    DISTANCE = DISTANCE * 1000  ; distance in meters   

EXIT_CALC:

    End
